#!/usr/bin/env python
#Copyright 2009 Diego Duclos
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.

from model.dataFolder import dataFolder
import urllib, sys, tarfile, ConfigParser, os

# Inform the user about download progress
def reporter(blocks, blockSize, fileSize):
	global progress
	percentage = float(blocks * blockSize) / float(fileSize) * 100
	if(percentage > progress):
		sys.stdout.write(".")
		sys.stdout.flush()
		progress += 10

# Download, extract and delete archives to the proper destination
def handleUpdate(name, url, destination):
	global progress

	print 'Downloading ' + name
	progress = 0
	urllib.urlretrieve(url, os.path.join(dataFolder, name) , reporter)

	print '\nExtracting ' + name
	archive = tarfile.open(os.path.join(dataFolder, name), 'r:bz2')
	archive.extractall(os.path.join(dataFolder, destination))
	archive.close()
	os.unlink(os.path.join(dataFolder, name))

# Downloads the latest ini file and checks the version of each file
# Initiates an update if needed
def checkIni():
	update = False

	if not os.path.exists(dataFolder):
		os.mkdir(dataFolder)
	if os.path.exists(os.path.join(dataFolder, 'testfiles.ini')):
		os.remove(os.path.join(dataFolder, 'testfiles.ini'))
		if os.path.exists(os.path.join(dataFolder, 'files.ini')):
			os.remove(os.path.join(dataFolder, 'files.ini'))
		
	if os.path.exists(os.path.join(dataFolder, 'files.ini')):
		iniOld = open(os.path.join(dataFolder, 'files.ini'))
	else:
		iniOld = open(os.path.join(dataFolder, 'files.ini'), 'w+')

	try:
		iniNew = urllib.urlopen('http://pyfa.sourceforge.net/files.ini')
	except:
		print "Couldn't update. The update server is probably down."
		sys.exit(-10)

	configOld = ConfigParser.ConfigParser()
	configOld.readfp(iniOld)

	configNew = ConfigParser.ConfigParser()
	try:
		configNew.readfp(iniNew)
	except:
		print "Couldn't update. The update server is probably down."
		sys.exit(-10)

	for section in configNew.sections():
		try:
			if configNew.get(section, 'version') > configOld.get(section, 'version'):
				update = True
				handleUpdate(section, configNew.get(section, 'url'), configNew.get(section, 'destination'))
		except ConfigParser.NoSectionError:
			update = True
			handleUpdate(section, configNew.get(section, 'url'), configNew.get(section, 'destination'))
	
	iniOld.close()
	iniNew.close()
	if update:
		urllib.urlretrieve('http://pyfa.sourceforge.net/files.ini', os.path.join(dataFolder, 'files.ini'))
		print 'Wrote new ini file.'

# Start update process
checkIni()

print 'All files up to date!'
