#!/usr/bin/env python
#Copyright 2009 Diego Duclos
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.
import platform
import sys
import gtk
import warnings
version = platform.python_version_tuple()
if int(version[0]) is 2 and int(version[1]) < 6:
    sys.stderr.write("WARNING: Python version needs to be at least 2.6.\n")
    sys.stderr.write("trying to run anyway, but expect errors or missing stats.\n")
    
if "-silent" in sys.argv:
    import os.path
    from model import dataFolder
    f = open(os.path.join(dataFolder.dataFolder, "pyfa.log"), "w")
    sys.stderr = f
    sys.stdout = f

if "-silent" in sys.argv or "-gtksilent" in sys.argv:
    import pango
    warnings.simplefilter('ignore', gtk.Warning)
    warnings.simplefilter('ignore', pango.Warning)

from gui import mainWindow
from gui import pluggable

if __name__ == "__main__":
    pluggable.load()
    window = mainWindow.mainWindow()
    window.main()
