#!/usr/bin/env python2.6
#Copyright 2009 Diego Duclos
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''
This script is used to strip down useless info from a full database dump
Full dumps can be found at http://wiki.eve-id.net/CCP_Database_Dump_Resources#Conversions
@author: cncfanatics
'''
from model.dataFolder import dataFolder
import bz2
import sqlite3
import shutil

dbPath = raw_input("Location of database ?")
print("copying database")
shutil.copy(dbPath, "eve.db")
print("opening copied db")
conn = sqlite3.connect("eve.db")
c = conn.cursor()
query = """
DROP TABLE trnTranslationColumns;
DROP TABLE trnTranslations;
DROP TABLE agtAgentTypes;
DROP TABLE agtAgents;
DROP TABLE agtConfig;
DROP TABLE agtResearchAgents;
DROP TABLE chrAncestries;
DROP TABLE chrAttributes;
DROP TABLE chrBloodlines;
DROP TABLE chrCareerSpecialities;
DROP TABLE chrCareers;
DROP TABLE chrFactions;
DROP TABLE chrRaceSkills;
DROP TABLE chrRaces;
DROP TABLE chrSchoolAgents;
DROP TABLE chrSchools;
DROP TABLE crpActivities;
DROP TABLE crpNPCCorporationDivisions;
DROP TABLE crpNPCCorporationResearchFields;
DROP TABLE crpNPCCorporations;
DROP TABLE crpNPCDivisions;
DROP TABLE crtCategories;
DROP TABLE crtCertificates;
DROP TABLE crtClasses;
DROP TABLE crtRelationships;
DROP TABLE eveNames;
DROP TABLE eveUnits;
DROP TABLE invBlueprintTypes;
DROP TABLE invContrabandTypes;
DROP TABLE invControlTowerResourcePurposes;
DROP TABLE invControlTowerResources;
DROP TABLE invFlags;
DROP TABLE invTypeReactions;
DROP TABLE mapCelestialStatistics;
DROP TABLE mapConstellationJumps;
DROP TABLE mapConstellations;
DROP TABLE mapDenormalize;
DROP TABLE mapJumps;
DROP TABLE mapLandmarks;
DROP TABLE mapRegionJumps;
DROP TABLE mapRegions;
DROP TABLE mapSolarSystemJumps;
DROP TABLE mapSolarSystems;
DROP TABLE mapUniverse;
DROP TABLE ramActivities;
DROP TABLE ramAssemblyLineStations;
DROP TABLE ramAssemblyLineTypeDetailPerCategory;
DROP TABLE ramAssemblyLineTypeDetailPerGroup;
DROP TABLE ramAssemblyLineTypes;
DROP TABLE ramAssemblyLines;
DROP TABLE staOperationServices;
DROP TABLE staOperations;
DROP TABLE staServices;
DROP TABLE staStationTypes;
DROP TABLE staStations;
DROP TABLE typeActivityMaterials;
"""
print("running queries")
c.executescript(query)
print("vacuuming")
c.execute("VACUUM;")
print("committing")
conn.commit()
print("closing sql connection")
conn.close()
print("opening new database")
f = open("eve.db", "rb")
data = f.read()
print("bzipping database")
compressed = bz2.compress(data)
print("writing bzipped database")
f = open("eve.db.bz2", "wb")
f.write(compressed)
print("all done")